#! /bin/sh
. /etc/profile
PATH=/sbin:/bin:/usr/sbin:/usr/bin

if [ -z "$DISK" ]; then
    DISK="mmcblk0"
fi

if [ "$(/usr/bin/id -u)" -ne 0 ]; then
    echo "$0 shall be run as root"
    exit 1
fi

start_sector=$(cat /sys/block/$DISK/${DISK}p4/start)
echo "Start sector is: $start_sector"

if [ -z "$start_sector" ]; then
	echo "Cannot find the start sector"
	exit 1
fi

echo "Expanding the partition"
sed -e 's/\s*\([\+0-9a-zA-Z]*\).*/\1/' << EOF | fdisk /dev/$DISK
d # delete partition
4 # number 4
n # new partition
p # primary partition
4 # partition number 4
$start_sector
  # default - end of disk 
p # print the in-memory partition table
w # write the partition table
q # and we're done
EOF